--- linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/cnc1900_fb_hw.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/cnc1900_fb_hw.c	2014-12-04 11:15:33.692449000 +0800
@@ -0,0 +1,559 @@
+
+/*
+ *  linux/drivers/video/celestial/cnc1800l_fb_hw.c -- Cavium celestial frame buffer device
+ *
+ *  Copyright (C) 2011 Cavium
+ *  Author: Xiaodong Fan
+ *
+ *  This file is subject to the terms and conditions of the GNU General Public
+ *  License. See the file COPYING in the main directory of this archive for
+ *  more details.
+ */
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/string.h>
+#include <linux/mm.h>
+#include <linux/tty.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+#include <asm/uaccess.h>
+#include <linux/fb.h>
+#include <linux/init.h>
+
+#include "cncfb.h"
+#include <mach/cnc1900_df.h>
+//#include <mach/df_reg_def_1900.h>
+//#include <mach/df_reg_fmt_1900.h>
+#include <mach/cnc1900_vpp_reg_def.h>
+#include "cnc19xx_fb_hw.h"
+#include <mach/cnc1900_power_clk.h>
+
+//#define FB_DEBUG
+#ifdef FB_DEBUG
+#define DEBUG(args...) 		\
+ 	do {						\
+        printk(KERN_INFO args); \
+	} while(0)
+#else
+#define DEBUG(args...) do { } while(0)
+#endif
+
+extern CNC_FB_INTERRUPT cncdf_1800_vblank_int[2];
+extern int __Is_TV;
+extern df_reg_para dfreg;
+extern int Get_Outif_Id(int gfx_id);
+extern void __df_update_start(void);
+extern void __df_update_end(void);
+
+extern unsigned int DF_Read(unsigned int addr);
+
+extern void DF_Write(unsigned int addr, unsigned int data);
+extern void DFGfxSetEndian(int GfxId, unsigned int GfxEndian);
+extern void DFGfxEna(int GfxId, int IsEna, int IsRGB2YUVEna);
+extern void DFGfxSetAlpha(int GfxId, unsigned short DefaultAlpha, unsigned short ARGB1555Alpha0, unsigned short ARGB1555Alpha1);
+extern void DFGfxGetAlpha(int GfxId, unsigned short *DefaultAlpha, unsigned short *ARGB1555Alpha0, unsigned short *ARGB1555Alpha1);
+extern void DFGfxColorKeyEna(int GfxId,int IsEna);
+extern void DFGfxSetColorKey(int GfxId, unsigned char KeyRMin, unsigned char KeyRMax, unsigned char KeyGMin, unsigned char KeyGMax, unsigned char KeyBMin, unsigned char KeyBMax);
+extern void DFSetZOrder(int OutIFId, int Gfx1ZOrder, int Gfx2ZOrder, int Video1ZOrder, int Video2ZOrder);
+extern void DFSetBackGroud(int OutIFId, unsigned char BGY, unsigned char BGU, unsigned char BGV);
+extern void DFGfxScalorCoef(void);
+extern void DFGfxOpaqueOnOff(int GfxId,int OnOff);
+extern void DFGfxConfigDistrect(int GfxId, unsigned int startx, unsigned int starty, unsigned int endx, unsigned int endy);
+
+//#define DF_GFX_Read(addr) (printk("df gfx addr=0x%x\n", addr),DF_Read(addr))
+#define DF_GFX_Read(addr) (DF_Read(addr))
+
+typedef enum _DF_GFX_COLOR_FORMAT_
+{
+	DF_GFX_CLUT4     = 0,
+	DF_GFX_CLUT8     = 1,
+	DF_GFX_RGB565    = 2,
+	DF_GFX_ARGB4444  = 3,
+	DF_GFX_A0        = 4,
+	DF_GFX_ARGB1555  = 5,
+	DF_GFX_ARGB8888  = 6,
+	DF_GFX_XRGB8888  = 7,
+	DF_GFX_FORMA_MAX,
+
+} DF_GFX_COLOR_FORMAT;
+#if 0
+static int dfreg_gfx[2][13] =
+{
+	{DISP_GFX1_CTRL,	//=0
+	DISP_GFX1_FORMAT,	//=1
+	DISP_GFX1_ALPHA_CTRL,	//=2
+	DISP_GFX1_KEY_RED,	//=3
+	DISP_GFX1_KEY_BLUE,	//=4
+	DISP_GFX1_KEY_GREEN,	//=5
+	DISP_GFX1_BUF_START,	//=6
+	DISP_GFX1_LINE_PITCH,	//=7
+	DISP_GFX1_X_POSITON,	//=8
+	DISP_GFX1_Y_POSITON,	//=9
+	},
+	{DISP_GFX2_CTRL,
+	DISP_GFX2_FORMAT,
+	DISP_GFX2_ALPHA_CTRL,
+	DISP_GFX2_KEY_RED,
+	DISP_GFX2_KEY_BLUE,
+	DISP_GFX2_KEY_GREEN,
+	DISP_GFX2_BUF_START,
+	DISP_GFX2_LINE_PITCH,
+	DISP_GFX2_X_POSITON,
+	DISP_GFX2_Y_POSITON,
+	},
+};
+#endif
+static int dfreg_gfx[2][14] =
+{
+	{
+	VPP_REG_GFX_UI1_CTRL,    //0
+	VPP_REG_GFX_UI1_ALPHA_CTRL,   // 1
+	VPP_REG_GFX_UI1_SIZE,   // 2
+	VPP_REG_GFX_UI1_KEY_RED,  // 3
+	VPP_REG_GFX_UI1_KEY_BLUE,  // 4
+	VPP_REG_GFX_UI1_KEY_GREEN,  // 5
+	VPP_REG_GFX_UI1_BUF_START,   // 6
+	VPP_REG_GFX_UI1_LINE_PITCH,   // 7
+	VPP_REG_GFX_UI1_X_POSITON,   // 8
+	VPP_REG_GFX_UI1_Y_POSITON,   // 9
+	VPP_REG_GFX_UI1_BUF_START_3D,  // 10
+	VPP_REG_GFX_UI1_A8,    // 11
+	VPP_REG_GFX_UI1_PHASE,   // 12
+	VPP_REG_GFX_UI1_COEFF_GID,   // 13
+	},
+	{
+	VPP_REG_GFX_UI2_CTRL,
+	VPP_REG_GFX_UI2_ALPHA_CTRL,
+	VPP_REG_GFX_UI2_SIZE,
+	VPP_REG_GFX_UI2_KEY_RED,
+	VPP_REG_GFX_UI2_KEY_BLUE,
+	VPP_REG_GFX_UI2_KEY_GREEN,
+	VPP_REG_GFX_UI2_BUF_START,
+	VPP_REG_GFX_UI2_LINE_PITCH,
+	VPP_REG_GFX_UI2_X_POSITON,
+	VPP_REG_GFX_UI2_Y_POSITON,
+	VPP_REG_GFX_UI2_BUF_START_3D,
+	VPP_REG_GFX_UI2_A8,
+	VPP_REG_GFX_UI2_PHASE,
+	VPP_REG_GFX_UI2_COEFF_GID,
+	},
+};
+
+
+
+/************************************* FUNCTION *****************************************/
+static unsigned int coefffirst=1;
+#ifdef CONFIG_ANDROID_FB0_ONLY
+unsigned int firsttime=1;
+#endif
+int update_gfx_layer(struct fb_info *info, int init, struct cnc_info * cncfbinfo)
+{
+	unsigned int outif_id = 0;
+	int i_node = info->node;
+	unsigned int tmp;
+	//printk(KERN_INFO"#### info->node=%d\n\r",info->node);
+        if (i_node > 1) i_node -= 2;
+
+
+	//DEBUG("node=%d: update gfx register!\n", info->node);
+	__df_update_start();
+
+	/* if info->node > 1,  only update gfx color format */
+	if (info->node == 2 || info->node == 3) {
+
+		dfreg.Gfx[info->node -2].reg_gfx_ui_ctrl.val=DF_GFX_Read(dfreg_gfx[info->node -2][0]);
+		dfreg.Gfx[info->node -2].reg_gfx_ui_line_pitch.val=DF_GFX_Read(dfreg_gfx[info->node -2][7]);
+
+		dfreg.Gfx[info->node - 2].reg_gfx_ui_ctrl.bits.gfx_ui_format=
+			(info->var.bits_per_pixel == 4) ? DF_GFX_CLUT4 :
+			(info->var.bits_per_pixel == 8) ? DF_GFX_CLUT8 :
+			(info->var.transp.length  == 0) ? DF_GFX_RGB565 :
+			(info->var.transp.length  == 1) ? DF_GFX_ARGB1555 :
+			(info->var.transp.length  == 4) ? DF_GFX_ARGB4444 :
+			(info->var.transp.length  == 8) ? DF_GFX_ARGB8888 :
+			(info->var.transp.length  == 32) ? DF_GFX_A0 :
+			dfreg.Gfx[info->node - 2].reg_gfx_ui_ctrl.bits.gfx_ui_format;
+
+
+		DF_Write((dfreg_gfx[info->node -2][0]), dfreg.Gfx[info->node -2].reg_gfx_ui_ctrl.val);
+        __df_update_end();
+        return 0;
+    }
+
+	dfreg.Gfx[info->node].reg_gfx_ui_ctrl.val = DF_GFX_Read(dfreg_gfx[info->node][0]);
+	dfreg.Gfx[info->node].reg_gfx_ui_buf_start.val = DF_GFX_Read(dfreg_gfx[info->node][6]);
+	dfreg.Gfx[info->node].reg_gfx_ui_line_pitch.val = DF_GFX_Read(dfreg_gfx[info->node][7]);
+	dfreg.Gfx[info->node].reg_gfx_ui_x_position.val = DF_GFX_Read(dfreg_gfx[info->node][8]);
+	dfreg.Gfx[info->node].reg_gfx_ui_y_position.val = DF_GFX_Read(dfreg_gfx[info->node][9]);
+
+
+	dfreg.Gfx[info->node ].reg_gfx_ui_ctrl.bits.gfx_ui_format=
+		(info->var.bits_per_pixel == 4) ? DF_GFX_CLUT4 :
+		(info->var.bits_per_pixel == 8) ? DF_GFX_CLUT8 :
+		(info->var.transp.length == 0) ? DF_GFX_RGB565 :
+		(info->var.transp.length == 1) ? DF_GFX_ARGB1555 :
+		(info->var.transp.length == 4) ? DF_GFX_ARGB4444 :
+		(info->var.transp.length == 8) ? DF_GFX_ARGB8888 :
+		(info->var.transp.length == 32) ? DF_GFX_A0 :
+
+		dfreg.Gfx[info->node ].reg_gfx_ui_ctrl.bits.gfx_ui_format;
+
+	dfreg.Gfx[info->node ].reg_gfx_ui_ctrl.bits.ui_tg1_en=1;
+
+
+	dfreg.Gfx[info->node].reg_gfx_ui_buf_start.val=
+        (info->fix.smem_start +
+         info->fix.line_length * info->var.yoffset +
+         info->var.xoffset * info->var.bits_per_pixel / 8);
+
+	dfreg.Gfx[info->node].reg_gfx_ui_line_pitch.val =  info->fix.line_length;
+#ifdef CONFIG_ANDROID_FB0_ONLY
+    if(firsttime)
+		{
+	          dfreg.Gfx[info->node].reg_gfx_ui_x_position.bits.gfx_ui_dst_x_start = info->var.left_margin;
+	          dfreg.Gfx[info->node].reg_gfx_ui_x_position.bits.gfx_ui_dst_x_end = (info->var.left_margin + info->var.xres) - 1;
+	          dfreg.Gfx[info->node].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_start	=info->var.upper_margin;
+
+	           dfreg.Gfx[info->node].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_end =info->var.upper_margin + info->var.yres;
+			firsttime=0;
+		}
+#else
+	dfreg.Gfx[info->node].reg_gfx_ui_x_position.bits.gfx_ui_dst_x_start = info->var.left_margin;
+	dfreg.Gfx[info->node].reg_gfx_ui_x_position.bits.gfx_ui_dst_x_end = (info->var.left_margin + info->var.xres) - 1;
+	dfreg.Gfx[info->node].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_start	=info->var.upper_margin;
+
+	dfreg.Gfx[info->node].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_end =info->var.upper_margin + info->var.yres;
+#endif
+
+
+	if(init) {
+		DFGfxSetAlpha(info->node, 0xff, 0, 0);
+		DFGfxEna(info->node, 1, __Is_TV);
+		DFGfxSetColorKey(info->node, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);
+		DFGfxColorKeyEna(info->node, 1);
+		DFGfxOpaqueOnOff(info->node, 0);
+	}
+
+	 // dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_ena                       = 1;
+   // dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_format                    = UiFormat; // rgb32
+   // dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_endian                    = 0;
+   // dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_opaque                    = 0;
+   // dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_color_keying_en           = 0;
+   // dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_color_keying_en           = 1;
+    dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_ena_premul                = 0;
+    dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_af_sc_dis                 = 0;//scaler
+
+        dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_antiflicker_en_a          = 1;
+        dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_antiflicker_en_c          = 1;
+
+    dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_ena_demul                 = 0;
+    //dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_yuv_conv_ena              = 1;
+    dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.gfx_ui_bw_limit                  = 0;
+    dfreg.Gfx[info->node].reg_gfx_ui_ctrl.bits.ui_tg1_en                        = 1; // ui1,ui2 using tg1 switch
+
+
+    dfreg.Gfx[info->node].reg_gfx_ui_size.bits.gfx_ui_src_width                 = info->var.xres;//1920;//ui1_src_width ;
+#ifdef CONFIG_ANDROID_FB0_ONLY
+    dfreg.Gfx[info->node].reg_gfx_ui_size.bits.gfx_ui_src_height                = info->var.yres;
+#else
+    tmp=dfreg.Gfx[info->node].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_end-dfreg.Gfx[info->node].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_start;
+    dfreg.Gfx[info->node].reg_gfx_ui_size.bits.gfx_ui_src_height                =tmp;//1080;//ui1_src_height;
+#endif
+
+    //ui.reg_gfx_ui_alpha_ctrl.bits.gfx_ui_default_alpha       = 200;
+    //dfreg.Gfx[info->node].reg_gfx_ui_alpha_ctrl.bits.gfx_ui_default_alpha       = 255;
+    //dfreg.Gfx[info->node].reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a0         = 100;
+    //dfreg.Gfx[info->node].reg_gfx_ui_alpha_ctrl.bits.gfx_ui_argb1555_a1         = 100;
+
+    /*dfreg.Gfx[info->node].reg_gfx_ui_key_red.bits.gfx_ui_r_min                  = 10;
+    dfreg.Gfx[info->node].reg_gfx_ui_key_red.bits.gfx_ui_r_max                  = 200;
+
+    dfreg.Gfx[info->node].reg_gfx_ui_key_green.bits.gfx_ui_g_min                = 10;
+    dfreg.Gfx[info->node].reg_gfx_ui_key_green.bits.gfx_ui_g_max                = 200;
+
+    dfreg.Gfx[info->node].reg_gfx_ui_key_blue.bits.gfx_ui_b_min                 = 10;
+    dfreg.Gfx[info->node].reg_gfx_ui_key_blue.bits.gfx_ui_b_max                 = 200;*/
+
+   //dfreg.Gfx[info->node].reg_gfx_ui_buf_start.bits.gfx_ui_buf_start            = Addr;
+    dfreg.Gfx[info->node].reg_gfx_ui_buf_start_3d.bits.gfx_ui_buf_start_3d      = dfreg.Gfx[info->node].reg_gfx_ui_buf_start.bits.gfx_ui_buf_start ;
+
+    //dfreg.Gfx[info->node].reg_gfx_ui_line_pitch.bits.gfx_ui_line_pitch          = LinePitch; //1920*4; // ????//bytes per line
+
+    //dfreg.Gfx[info->node].reg_gfx_ui_x_position.bits.gfx_ui_dst_x_start         =DesStartPosX;// SrcDstParam.DesStartX;//ui1_dst_x_start; // 10;
+   // dfreg.Gfx[info->node].reg_gfx_ui_x_position.bits.gfx_ui_dst_x_end           = DesEndPosX;//SrcDstParam.DesEndX;//ui1_dst_x_end  ; // 1024-10;
+
+    //dfreg.Gfx[info->node].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_start         = DesStartPosY;//SrcDstParam.DesStartY;//ui1_dst_y_start; // 10;
+    //dfreg.Gfx[info->node].reg_gfx_ui_y_position.bits.gfx_ui_dst_y_end           = DesEndPosY;//SrcDstParam.DesEndY;//ui1_dst_y_end  ; // 720-10;
+
+    dfreg.Gfx[info->node].reg_gfx_ui_a8.bits.gfx_ui_a8_r                        = 100;
+    dfreg.Gfx[info->node].reg_gfx_ui_a8.bits.gfx_ui_a8_g                        = 100;
+    dfreg.Gfx[info->node].reg_gfx_ui_a8.bits.gfx_ui_a8_b                        = 100;
+
+    dfreg.Gfx[info->node].reg_gfx_ui_phase.bits.gfx_ui_hphase                   = 0;
+    dfreg.Gfx[info->node].reg_gfx_ui_phase.bits.gfx_ui_vphase                   = 32;
+
+    dfreg.Gfx[info->node].reg_gfx_ui_coeff_gid.bits.gfx_ui_hcoeff_gid           = 15;
+    dfreg.Gfx[info->node].reg_gfx_ui_coeff_gid.bits.gfx_ui_vcoeff_gid           = 15;
+
+
+	DF_Write((dfreg_gfx[info->node][0]), dfreg.Gfx[info->node].reg_gfx_ui_ctrl.val);
+	DF_Write((dfreg_gfx[info->node][1]), dfreg.Gfx[info->node].reg_gfx_ui_alpha_ctrl.val);
+	DF_Write((dfreg_gfx[info->node][2]), dfreg.Gfx[info->node].reg_gfx_ui_size.val);
+	DF_Write((dfreg_gfx[info->node][3]), dfreg.Gfx[info->node].reg_gfx_ui_key_red.val);
+	DF_Write((dfreg_gfx[info->node][4]), dfreg.Gfx[info->node].reg_gfx_ui_key_blue.val);
+	DF_Write((dfreg_gfx[info->node][5]), dfreg.Gfx[info->node].reg_gfx_ui_key_green.val);
+	DF_Write((dfreg_gfx[info->node][6]), dfreg.Gfx[info->node].reg_gfx_ui_buf_start.val);
+	DF_Write((dfreg_gfx[info->node][7]), dfreg.Gfx[info->node].reg_gfx_ui_line_pitch.val);
+	DF_Write((dfreg_gfx[info->node][8]), dfreg.Gfx[info->node].reg_gfx_ui_x_position.val);
+	DF_Write((dfreg_gfx[info->node][9]), dfreg.Gfx[info->node].reg_gfx_ui_y_position.val);
+	DF_Write((dfreg_gfx[info->node][10]), dfreg.Gfx[info->node].reg_gfx_ui_buf_start_3d.val);
+	DF_Write((dfreg_gfx[info->node][11]), dfreg.Gfx[info->node].reg_gfx_ui_a8.val);
+	DF_Write((dfreg_gfx[info->node][12]), dfreg.Gfx[info->node].reg_gfx_ui_phase.val);
+	//DF_Write((dfreg_gfx[info->node][13]), dfreg.Gfx[info->node].reg_gfx_ui_coeff_gid.val);
+
+        if(coefffirst)
+        {
+	DF_Write((dfreg_gfx[info->node][13]), dfreg.Gfx[info->node].reg_gfx_ui_coeff_gid.val);
+	coefffirst=0;
+        }
+
+	__df_update_end();
+
+	if (i_node > 1) i_node -= 2;
+	outif_id = Get_Outif_Id(i_node);
+
+	if(cncdf_1800_vblank_int[outif_id].is_display == 1){
+		wait_event_interruptible(cncdf_1800_vblank_int[outif_id].wait, cncdf_1800_vblank_int[outif_id].is_display == 0);
+	}
+
+
+	DFGfxScalorCoef();
+	return 0;
+}
+
+int cncfb_hw_init(struct fb_info *info, int en_flags, struct cnc_info * cncfbinfo)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+
+	/*clock_gfx_clockena(_clock_enable);temp removed*/
+	clock_gpu_enaclock(_clock_enable);
+	clock_gfx_reset(_do_reset);
+	msleep(5);
+	clock_gfx_reset(_do_set);
+
+	init_waitqueue_head(&cncdf_1800_vblank_int[i_node].wait);
+	cncdf_1800_vblank_int[i_node].is_display = 0;
+	cncdf_1800_vblank_int[i_node].count = 0;
+	cncdf_1800_vblank_int[i_node].cur_fb_info = info;
+
+	if(en_flags){
+		update_gfx_layer(info, en_flags, cncfbinfo);
+	}
+	return 0;
+}
+
+void cncfb_show_logo(struct fb_info *info,struct cnc_info * cncfbinfo)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+
+	__df_update_start();
+	DFGfxScalorCoef();
+	DF_Write((dfreg_gfx[i_node][13]),DF_GFX_Read(dfreg_gfx[i_node][13]&0xffffff00)|0xff);
+	 printk(KERN_INFO" ####### set gid to 00000 #########\n");
+	 msleep(1);
+       DF_Write((dfreg_gfx[i_node][13]),DF_GFX_Read(dfreg_gfx[i_node][13]&0xffffff00));
+
+	dfreg.Gfx[info->node].reg_gfx_ui_buf_start.val=
+        (info->fix.smem_start +
+         info->fix.line_length * info->var.yoffset +
+         info->var.xoffset * info->var.bits_per_pixel / 8);
+	DF_Write((dfreg_gfx[info->node][6]), dfreg.Gfx[info->node].reg_gfx_ui_buf_start.val);
+	   __df_update_end();
+}
+
+
+void cncfb_hw_exit(void)
+{
+	return ;
+}
+
+int cncfb_hw_gfx_on(struct fb_info *info, unsigned int arg, struct cnc_info * cncfbinfo)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+
+    __df_update_start();
+	DFGfxEna(i_node, arg, __Is_TV);
+	cncfbinfo->fbs_lst[i_node].onoff = arg;
+	if(arg)
+		{
+		DF_Write((dfreg_gfx[i_node][13]),DF_GFX_Read(dfreg_gfx[i_node][13]&0xffffff00)|0xff);
+		 printk(KERN_INFO" ####### set gid to 00000 #########\n");
+                DF_Write((dfreg_gfx[i_node][13]),DF_GFX_Read(dfreg_gfx[i_node][13]&0xffffff00));
+		}
+
+    __df_update_end();
+
+	return 0;
+}
+
+int cncfb_hw_gfx_alpha(struct fb_info *info, unsigned int arg,struct cnc_info * cncfbinfo)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+
+	arg &= 0x3ff;
+
+	__df_update_start();
+
+	DFGfxSetAlpha(i_node, arg, 0, 0);
+
+	__df_update_end();
+
+	return 0;
+}
+
+int cncfb_hw_colorkey_on(struct fb_info *info, unsigned int arg, struct cnc_info * cncfbinfo)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+
+	__df_update_start();
+
+	DFGfxColorKeyEna(i_node, arg);
+
+	__df_update_end();
+
+	return 0;
+}
+
+
+int cncfb_hw_opaque_onoff(struct fb_info *info, unsigned long arg)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+
+	__df_update_start();
+
+	DFGfxOpaqueOnOff(i_node, arg);
+
+	__df_update_end();
+
+	return 0;
+}
+
+int cncfb_hw_config_distrect(struct fb_info *info, gfx_rect *arg)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+
+	__df_update_start();
+
+	DFGfxConfigDistrect(i_node, arg->startx, arg->starty, arg->endx, arg->endy);
+
+	__df_update_end();
+
+	return 0;
+}
+
+int cncfb_hw_colorkey_val(struct fb_info *info, gfx_colorkey *col_key, struct cnc_info * cncfbinfo)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+
+	__df_update_start();
+
+	DFGfxSetColorKey(i_node, col_key->r_min, col_key->r_max, col_key->g_min, col_key->g_max, col_key->b_min, col_key->b_max);
+
+	__df_update_end();
+
+	return 0;
+}
+
+int cncfb_hw_z_order(struct fb_info *info, unsigned int arg)
+{
+	int Video1ZOrder = (arg >>  0) & 0x3;
+	int Video2ZOrder = (arg >>  4) & 0x3;
+	int Gfx1ZOrder = (arg >> 8) & 0x3;
+	int Gfx2ZOrder = (arg >> 12) & 0x3;
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+
+	__df_update_start();
+	DFSetZOrder(i_node, Gfx1ZOrder, Gfx2ZOrder, Video1ZOrder, Video2ZOrder);
+	__df_update_end();
+
+	return 0;
+}
+
+int cncfb_hw_set_par(struct fb_info *info, struct cnc_info * cncfbinfo)
+{
+	return update_gfx_layer(info, 0, cncfbinfo);
+}
+
+int cncfb_hw_pan_display(struct fb_info *info, struct cnc_info * cncfbinfo)
+{
+	return update_gfx_layer(info, 0, cncfbinfo);
+}
+
+int cncfb_hw_waitforvsync(struct fb_info *info)
+{
+	unsigned int outif_id = 0;
+	int i_node = info->node;
+
+	if (i_node > 1) i_node -= 2;
+	outif_id = Get_Outif_Id(i_node);
+
+	cncdf_1800_vblank_int[outif_id].is_display = 1;
+
+	return 0;
+}
+
+int cncfb_hw_setbgcolor(struct fb_info *info, unsigned int arg)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+	__df_update_start();
+	DFSetBackGroud(i_node, (arg>>16)&0xff,  (arg>>8)&0xff, arg&0xff);
+	__df_update_end();
+	return 0;
+}
+
+int cncfb_hw_setendian(struct fb_info *info, unsigned int arg)
+{
+	int i_node = info->node;
+	if (i_node > 1) i_node -= 2;
+	__df_update_start();
+	DFGfxSetEndian(i_node, arg);
+	__df_update_end();
+	return 0;
+}
+
+int cncfb_hw_setcolreg(u_int regno, u_int red, u_int green, u_int blue,
+                         u_int transp, struct fb_info *info, struct cnc_info * cncfbinfo)
+{
+	/* TODO: implement CLUT table updating */
+	return 0;
+}
+
+int cncfb_hw_blank(int blank)
+{
+	/* TODO: to call an external functions from TVE modules */
+	return 0;
+}
+
+void df_writel(int addr, int val)
+{
+	DF_Write(addr, val);
+}
+
+int df_readl(int addr)
+{
+	return DF_GFX_Read(addr);
+}
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/cnc19xx_fb_hw.h linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/cnc19xx_fb_hw.h
--- linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/cnc19xx_fb_hw.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/cnc19xx_fb_hw.h	2014-12-04 11:15:33.692449000 +0800
@@ -0,0 +1,36 @@
+#ifndef __CNCFB_HW_H__
+#define __CNCFB_HW_H__
+
+void df_writel(int addr, int val);
+int df_readl(int addr);
+
+int cncfb_hw_init(struct fb_info *info, int en_flags, struct cnc_info *);
+void cncfb_hw_exit(void);
+
+int cncfb_hw_set_par(struct fb_info *info, struct cnc_info *);
+int cncfb_hw_pan_display(struct fb_info *info, struct cnc_info *);
+int cncfb_hw_setcolreg(u_int regno, u_int red, u_int green, u_int blue,
+                       u_int transp, struct fb_info *info, struct cnc_info *);
+
+int cncfb_hw_blank(int blank);
+int cncfb_hw_waitforvsync(struct fb_info *info);
+
+int cncfb_hw_gfx_on(struct fb_info *info, unsigned int args, struct cnc_info *);
+int cncfb_hw_gfx_alpha(struct fb_info *info, unsigned int args, struct cnc_info *);
+
+int cncfb_hw_z_order(struct fb_info *info,unsigned int arg);
+
+int cncfb_hw_colorkey_val(struct fb_info *info, gfx_colorkey *col_key, struct cnc_info *);
+int cncfb_hw_colorkey_on(struct fb_info *info, unsigned int arg, struct cnc_info *);
+
+
+int cncfb_hw_setbgcolor(struct fb_info *info, unsigned int arg);
+int cncfb_hw_waitforvsync(struct fb_info *info);
+
+int cncfb_hw_opaque_onoff(struct fb_info *info, unsigned long arg);
+int cncfb_hw_config_distrect(struct fb_info * info, gfx_rect * arg);
+
+int cncfb_hw_setendian(struct fb_info *info, unsigned int arg);
+
+void cncfb_show_logo(struct fb_info *info,struct cnc_info * cncfbinfo);
+#endif /* __CNCFB_HW_H__ */
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/cnc_2d.c linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/cnc_2d.c
